C
C  B.R. WEBBER'S GBOOK->MONGO INTERFACE
C
      SUBROUTINE GMONGO(ID,IUNIT,IOPT,NEVENTS)
C  WRITES TITLE AND CONTENTS OF 1-D GBOOK HISTOGRAM ID,
C  NORMALISED TO BINSIZE*NEVENTS, ON UNIT IUNIT
C  IN FORMAT SUITABLE FOR MONGO (OR SIMILAR) PLOTTING PACKAGE
C  IOPT=0  LINEAR, NO ERRORS
C       1  LINEAR WITH ERRORS
C       2  LOG PLOT, NO ERRORS
C       3  LOG PLOT WITH ERRORS
C  (NORMALIZATION SUPPRESSED BY ADDING 10 TO IOPT)
C  N.B. ERRORS ASSUME ALL ENTRIES HAVE SAME WEIGHT
C------------------------------------------------------------------------
      COMMON /GBOOK/ A(20000)
      CHARACTER TITLE*60
      EQUIVALENCE (REQ,IEQ)
      CALL GTITLE(ID,TITLE,LENTIT)
C  SET UP PAGE...
      WRITE (IUNIT,*) ' NEW FRAME'
      WRITE (IUNIT,*) ' SET FONT DUPLEX'
      WRITE (IUNIT,*) ' SET SCALE Y LOG'
      WRITE (IUNIT,*) ' TITLE TOP ''',TITLE(1:LENTIT),''''
      WRITE (IUNIT,*) ' SET SYMBOL 0O'
C
      IS=A(ID+2)+0.5
      ENTRIES=A(IS+9)
      IF (ENTRIES.LT.0.5) RETURN
      NX=INT(A(IS+1)+0.5)
      BINSIZE=A(IS+4)
      IF (IOPT.LT.10) THEN
        JOPT=IOPT
        RESCALE=1./(BINSIZE*FLOAT(NEVENTS))
      ELSE
        JOPT=IOPT-10
        RESCALE=1.
      ENDIF
      IF (JOPT.EQ.1.OR.JOPT.EQ.3) THEN
        WRITE (IUNIT,*) ' SET ORDER X Y DY'
      ELSE
        WRITE (IUNIT,*) ' SET ORDER X Y'
      ENDIF
      WGTMEAN=(A(IS+13)+A(IS+14)+A(IS+15))/ENTRIES
      DO 120 IX=1,NX
      X=BINSIZE*(IX-0.5)+A(IS+2)
      W=A(IS+18+IX)
      IF (JOPT.LT.2) THEN
        Y=W*RESCALE
        IF (JOPT.EQ.0) THEN
          WRITE(IUNIT,119) X,Y
        ELSE
          Z=SQRT(ABS(W*WGTMEAN))*RESCALE
          WRITE(IUNIT,119) X,Y,Z
        ENDIF
      ELSE
        IF (W.LE.0.) THEN
          Y=-50.
        ELSE
          Y=ALOG10(W*RESCALE)
        ENDIF
        IF (JOPT.EQ.2) THEN
          WRITE(IUNIT,119) X,Y
        ELSE
          IF (W.LE.0.) THEN
            ZP=0.
            ZM=0.
          ELSE
            Z=SQRT(WGTMEAN/W)
            ZP=ALOG10(1.+Z)
            IF (W.GT.1.) THEN
              ZM=-ALOG10(1.-Z)
            ELSE
              ZM=50.
            ENDIF
          ENDIF
          WRITE(IUNIT,119) X,Y,ZP,ZM
        ENDIF
      ENDIF
  119 FORMAT(4E15.5)
  120 CONTINUE
      WRITE (IUNIT,*) ' PLOT'
      END
C------------------------------------------------------------------------
      SUBROUTINE GFECH1(ID,IB,X,W)
C  FETCHES CENTRE AND WEIGHT OF BIN IB IN GBOOK HISTOGRAM ID
      COMMON /GBOOK/ A(20000)
      IS=A(ID+2)+0.5
      X=A(IS+4)*(IB-0.5)+A(IS+2)
      NB=INT(A(IS+1)+0.5)
      ENTRIES=A(IS+9)
      IF (ENTRIES.LT.0.5.OR.IB.LT.1.OR.IB.GT.NB) THEN
        W=0.
      ELSE
        W=A(IS+18+IB)
      ENDIF
      END
C------------------------------------------------------------------------
      SUBROUTINE GFECH2(ID,IX,IY,X,Y,W)
C  FETCHES CENTRE AND WEIGHT OF BIN (IX,IY) IN GBOOK 2-D HISTOGRAM ID
      COMMON /GBOOK/ A(20000)
      IS=A(ID+2)+0.5
      X=A(IS+4)*(IX-0.5)+A(IS+2)
      Y=A(IS+8)*(IY-0.5)+A(IS+6)
      NX=INT(A(IS+1)+0.5)
      NY=INT(A(IS+5)+0.5)
      ENTRIES=A(IS+9)
      IF (ENTRIES.LT.0.5.OR.IX.LT.1.OR.IX.GT.NX
     &                  .OR.IY.LT.1.OR.IY.GT.NY) THEN
        W=0.
      ELSE
        W=A(IS+18+NX*(IY-1)+IX)
      ENDIF
      END
C------------------------------------------------------------------------
      SUBROUTINE GTOPDR(ID,NEW,HIST,LOG)
C
C  M SEYMOUR'S GBOOK->TOPDRAWER INTERFACE
C  WRITES HISTOGRAM WITH TOPDRAWER PACKAGE
C
C  NEW  IS .TRUE.  TO PUT HISTOGRAM ON A NEW PAGE
C          .FALSE. TO PUT IT ON TOP OF THE LAST ONE
C
C  HIST IS .TRUE.  FOR HISTOGRAM
C          .FALSE. FOR GRAPH
C
C  LOG  IS .TRUE.  FOR LOGARITHMIC Y-SCALE 
C          .FALSE. FOR LINEAR Y-SCALE       
C
C  .TRUE.  MAY BE ABBREVIATED TO 1 WHEN CALLING, AND
C  .FALSE. TO 0
C
C  IF LOG IS SELECTED, THEN ALL ZERO OR NEGATIVE BINS ARE SET TO
C  ONE HUNDREDTH OF THE LOWEST POSITIVE BIN
C
      COMMON /GBOOK/ A(20000)
      LOGICAL NEW,HIST,LOG
      IS=NINT(A(ID+2))
      IF (A(IS+14) .EQ. 0.0) THEN
         WRITE (6,1000) ID
      ELSE
         WRITE (6,1010) ID
         IF (A(IS+5) .LT. 1.5) THEN
            CALL GTOP1(ID,NEW,HIST,LOG)
         ELSE
            CALL GTOP2(ID,NEW)
         ENDIF
      ENDIF
 1000 FORMAT (/5X,'HISTOGRAM NO',I4,' : NO ENTRIES FOUND')
 1010 FORMAT (/5X,'HISTOGRAM NO',I4,' : OUTPUTTING TO TOPDRAWER FILE')
      END

      SUBROUTINE GTOP1(ID,NEW,HIST,LOG)
      COMMON /GBOOK/ A(20000)
      COMMON /GOPEN/ OPEN
      LOGICAL NEW,HIST,LOG, OPEN
      REAL X(100),Y(100)
      CHARACTER TITLE*60
      IF (.NOT.OPEN) THEN
         OPEN (21,FILE='GTOPDRAW.TOP',STATUS='NEW')
         OPEN=.TRUE.
      ELSEIF (NEW) THEN
         WRITE (21,*) 'NEW FRAME'
      ENDIF
      WEIGHT=0.0
      AVGE=0.0
      VARIAN=0.0
      IS=NINT(A(ID+2))
      YMIN=1E30
      DO 50  IX=1, NINT(A(IS+1))
 50      IF (A(IS+18+IX).GT.0.0) YMIN=MIN(YMIN,A(IS+18+IX))
      DO 100 IX=1, NINT(A(IS+1))
         X(IX)=(IX-0.5)*A(IS+4)+A(IS+2)
         Y(IX)=A(IS+18+IX)
         WEIGHT=WEIGHT+Y(IX)
         AVGE=AVGE+X(IX)*Y(IX)
         VARIAN=VARIAN+X(IX)**2*Y(IX)
         IF (LOG .AND. Y(IX).LE.0.0) THEN
            WRITE (6,2000) Y(IX),YMIN/100
            Y(IX)=YMIN/100
         ENDIF
 100  CONTINUE
      AVGE=AVGE/WEIGHT
      VARIAN=VARIAN/WEIGHT-AVGE**2
      CALL GTITLE(ID,TITLE,LENTIT)
C  SET UP PAGE...
      IF (NEW) THEN
         WRITE (21,*) 'SET FONT DUPLEX'
         IF (LOG) WRITE (21,*) 'SET SCALE Y LOG'
         WRITE (21,*) 'TITLE TOP ''',TITLE(1:LENTIT),''''
      ENDIF
C  PLOT...
      DO 200 I=1, NINT(A(IS+1))
 200     WRITE (21,*) X(I),Y(I)
      IF (HIST) THEN
         WRITE (21,*) 'HIST'
      ELSE
         WRITE (21,*) 'JOIN'
      ENDIF
      WRITE (6,1000) A(IS+13)
      WRITE (6,1010) A(IS+14)
      WRITE (6,1020) A(IS+15)
      WRITE (6,1030) AVGE
      IF (VARIAN.GE.0.0) THEN
         WRITE (6,1040) SQRT(VARIAN)
      ELSE
         WRITE (6,1050) VARIAN
      ENDIF
 1000 FORMAT (5X,'Total underflow=',F10.3)
 1010 FORMAT (5X,'Total entry    =',F10.3)
 1020 FORMAT (5X,'Total overflow =',F10.3)
 1030 FORMAT (5X,'Mean value        =',E10.3)
 1040 FORMAT (5X,'Standard deviation=',E10.3)
 1050 FORMAT (5X,'Variance          =',E10.3)
 2000 FORMAT (5X,'WARNING:',E10.3,' cannot be logged. Now using',E10.3)
      END

      SUBROUTINE GTOP2(ID,NEW)
      COMMON /GBOOK/ A(20000)
      COMMON /GOPEN/ OPEN
      LOGICAL NEW, OPEN
      REAL Z(100,100)
      CHARACTER TITLE*60
      IF (.NOT.OPEN) THEN
         OPEN (21,FILE='GTOPDRAW.TOP',STATUS='NEW')
         OPEN=.TRUE.
      ELSEIF (NEW) THEN
         WRITE (21,*) 'NEW FRAME'
      ENDIF
      WEIGHT=0.0
      XAVGE=0.0
      XVARIN=0.0
      YVGE=0.0
      YVARIN=0.0
      ZMAX=0
      IS=NINT(A(ID+2))
      NX=NINT(A(IS+1))
      NY=NINT(A(IS+5))
      DO 100 IX=1, NX
      DO 100 IY=1, NY
         X=(IX-1)*A(IS+4)+A(IS+2)
         Y=(IY-1)*A(IS+8)+A(IS+6)
         Z(IX,IY)=A(IS+18+NX*(IY-1)+IX)
         IF (ABS(Z(IX,IY)).LT.1E-10) Z(IX,IY)=0.0
         IF (Z(IX,IY).GT.ZMAX) ZMAX=Z(IX,IY)
         WEIGHT=WEIGHT+Z(IX,IY)
         XAVGE=XAVGE+X*Z(IX,IY)
         XVARIN=XVARIN+X**2*Z(IX,IY)
         YAVGE=YAVGE+Y*Z(IX,IY)
         YVARIN=YVARIN+Y**2*Z(IX,IY)
 100  CONTINUE
      IF (ZMAX.GT.1 .AND. ZMAX.LT.100) ZMAX=100
      XAVGE=XAVGE/WEIGHT
      XVARIN=XVARIN/WEIGHT-XAVGE**2
      YAVGE=YAVGE/WEIGHT
      YVARIN=YVARIN/WEIGHT-YAVGE**2
      CALL GTITLE(ID,TITLE,LENTIT)
C  SET UP PAGE...
      IF (NEW) THEN
         WRITE (21,*) 'SET FONT DUPLEX'
changed hannes:        IF (LOG) WRITE (21,*) 'SET SCALE Y LOG'
         WRITE (21,*) 'TITLE TOP ''',TITLE(1:LENTIT),''''
      ENDIF
C  PLOT...
      DO 200 IX=1, NX
      DO 200 IY=1, NY
      DO 200 IZ=1, NINT(100*Z(IX,IY)/ZMAX)
         X=(IX+HWRUNI(0,-1.,0))*A(IS+4)+A(IS+2)
         Y=(IY+HWRUNI(0,-1.,0))*A(IS+8)+A(IS+6)
         WRITE (21,*) X,Y
 200  CONTINUE
      WRITE (6,1000)
      WRITE (6,1010) (A(IS+J), J=10,12)
      WRITE (6,1020) (A(IS+J), J=13,15)
      WRITE (6,1030) (A(IS+J), J=16,18)
      WRITE (6,1040) XAVGE
      WRITE (6,1050) SQRT(XVARIN)
      WRITE (6,1060) YAVGE
      WRITE (6,1070) SQRT(YVARIN)
 1000 FORMAT (20X,'   X under',5X,' X on grid',5X,'    X over')
 1010 FORMAT (5X,'   Y under',3(5X,F10.3))
 1020 FORMAT (5X,' Y on grid',3(5X,F10.3))
 1030 FORMAT (5X,'    Y over',3(5X,F10.3))
 1040 FORMAT (5X,'Mean x value        =',E10.3)
 1050 FORMAT (5X,'X standard deviation=',E10.3)
 1060 FORMAT (5X,'Mean y value        =',E10.3)
 1070 FORMAT (5X,'Y standard deviation=',E10.3)
      END
 
      SUBROUTINE GTITLE(ID,TITLE,LENTIT)
      COMMON /GBOOK/ A(20000)
      CHARACTER TITLE*60
      EQUIVALENCE (REQ,IEQ)
      IS=NINT(A(ID+2))
      NX=NINT(A(IS+1))
      NY=NINT(A(IS+5))
      DO 100 IT=1, 20
         REQ=A(IS+18+NX*NY+IT)
         TITLE(3*IT-2:3*IT)=CHAR(IEQ/256**2)//CHAR(MOD(IEQ,256**2)
     &      /256)//CHAR(MOD(IEQ,256))
 100  CONTINUE
      LENTIT=60
 200  IF (LENTIT.GT.1 .AND. TITLE(LENTIT:LENTIT).EQ.' ') THEN
         LENTIT=LENTIT-1
         GOTO 200
      ENDIF
      END

